var get_types_properties_html_box = '';
var button;
var table_id;
var update_counter = 0;

jQuery(document).ready(function() {
    
    jQuery.noConflict();

    jQuery('.sortable' ).sortable({
        placeholder: 'ui-state-highlight',
        forcePlaceholderSize: true,
        items: 'li:not(.sort-disabled)',
        start: function(e, ui) { 
            ui.placeholder.css({
                'visibility' : 'visible',
                'background-color' : '#FFFFD6'
            });
        },
        stop:  function (event, ui) {
            shift_schedule_698_updateTypes();
        }
    }).disableSelection();

    
    get_types_properties_html_box = jQuery('#get_types_properties').html();
    jQuery('#get_types_properties').remove();
    shift_schedule_698_updateTypes();
    
    jQuery(".day").click(function (e) {
        var $this = jQuery(this);


        if ($this.hasClass('clicked')){
            $this.removeClass('clicked'); 
            shift_schedule_698_updated_display_on();
    
            shift_schedule_698_setBossFlag($this);
        } else {
            $this.addClass('clicked');
            setTimeout(function() { 
                if ($this.hasClass('clicked')){
                    $this.removeClass('clicked'); 
                    
                    shift_schedule_698_updated_display_on();
    
                    shift_schedule_698_setDayFlag($this);
                }
            }, 250);          
        }
    });
    
    table_id = '#schedules_' + jQuery('body').find('.schedules:first').attr('data-token');
    var days = [];
    
    jQuery(table_id + ' tbody').find('tr:first').find('[data-day]').each(function() {
        days.push( jQuery(this).attr('data-day') );
    });
    
    days.forEach(function(day) {
        shift_schedule_698_checkDayColl(day);
    });
    
    jQuery('#shift_schedule_category_selector').on('change', function() {
      jQuery(this).closest('form').submit();
    });

});

function shift_schedule_698_updated_display_on() {
    update_counter++;
    jQuery('#shift-schedule-form').find('button').prop('disabled', '1');
}

function shift_schedule_698_updated_display_off() {
    update_counter--;
    if (update_counter < 1) {
        update_counter = 0;
        jQuery('#shift-schedule-form').find('button').removeAttr('disabled');
        jQuery('table.schedules').find('.updated').removeClass('updated');
    }
}


function shift_schedule_698_setDayFlag(item) {
    // var set = jQuery('input[name=day_type]:checked').val();
    var set = jQuery('#day_type').val();
    var id = item.closest('tr').attr('data-id');
    var day = item.attr('data-day');

    var actual = item.attr('class')
                    .replace('day', '')
                    .trim()
                    .split(/\s+/);
    
    for (i = 0; i < shift_schedule_698_types.length; ++i) {
        if (shift_schedule_698_types[i].free == '1') {
            if (actual == shift_schedule_698_types[i].alias) {
                shift_schedule_698_updateFree(id, day, '+');
            } else {
                if (set == shift_schedule_698_types[i].alias) {
                    shift_schedule_698_updateFree(id, day, '-');
                }
            }
        }
    }
    
    if (item.hasClass(set)) {
    // Törlés
        item.removeClass(set);
        shift_schedule_698_setData(id, day, '');
        item.removeAttr('data-boss');
        shift_schedule_698_setBoss(id, day, 0);
    } else {
    // Beállítás 
        shift_schedule_698_torol(item);
        item.addClass(set);
        shift_schedule_698_setData(id, day, set);
    }
    shift_schedule_698_checkLine(item);
    shift_schedule_698_checkDayColl(day)
    item.addClass('updated');
}

function shift_schedule_698_torol(item) {
    item.attr('class', 'day');    
}

function shift_schedule_698_setBossFlag(item) {

    var classes = item.attr('class');
    for (i = 0; i < shift_schedule_698_types.length; ++i) {
        if (Number.isInteger(shift_schedule_698_types[i].hours) && (parseInt(shift_schedule_698_types[i].hours) > 0)) {
            classes = classes.replace(shift_schedule_698_types[i].alias, '');
        }
    }
    classes = classes.trim().split(/\s+/);
    
    if (classes.length <= 1) {
        return;
    }

    var boss = item.attr('data-boss');
    var id = item.closest('tr').attr('data-id');
    var day = item.attr('data-day');

    item.addClass('updated');

    if (parseInt(boss)> 0) {
        item.removeAttr('data-boss');
        shift_schedule_698_setBoss(id, day, 0);
    } else {
        item.attr('data-boss', 1);
        shift_schedule_698_setBoss(id, day, 1);
    }
}

function shift_schedule_698_updateFree(user, day, mode) {

    var html = '<span class="small spin dashicons dashicons-update"></span>';
    jQuery('#user_free_'+user).html(html);
    
    var data = {
            action : 'shift_schedule_698_update_free',
            user    : user,
            day     : jQuery(table_id).attr('data-month')+'-'+day,
            mode    : mode
        };
        
    jQuery.ajax({
        url      : shift_schedule_698_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery('#user_free_'+data.user).text(data.day);
            } else {
                console.log(data.error);
            }
        } 
    });
}

function shift_schedule_698_setBoss(user, day, boss) {

    var data = {
            action : 'shift_schedule_698_set_boss',
            user    : user,
            day     : jQuery(table_id).attr('data-month')+'-'+day,
            boss    : boss
        };
        
    jQuery.ajax({
        url      : shift_schedule_698_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            
            shift_schedule_698_updated_display_off();
            
            if (data.status == 1) {
                // Status OK
            } else {
                console.log(data.error);
            }
        } 
    });
}

function shift_schedule_698_setData(user, day, flag) {

    var data = {
            action : 'shift_schedule_698_set_flag',
            user    : user,
            day     : jQuery(table_id).attr('data-month')+'-'+day,
            flag    : flag
        };
        
    jQuery.ajax({
        url      : shift_schedule_698_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){

            shift_schedule_698_updated_display_off();
            
            if (data.status == 1) {
                // Status OK
            } else {
                console.log(data.error);
            }
        } 
    });
}


function shift_schedule_698_showNewTypeBox() {

    shift_schedule_698_showTypeBox();
    var id = 'types_' + jQuery('#shift_schedule_698_types li').length;
    jQuery('#types_id').val(id);
    jQuery('#edit_type_button').hide();
}

function shift_schedule_698_editTypeBox(item) {

    shift_schedule_698_showTypeBox();
    jQuery('#add_new_type_button').hide();

    item = item.closest('li');
    jQuery('#types_id').val( item.attr('id') );
    jQuery('#types_title').val( item.attr('data-title') );
    jQuery('#types_alias').val( item.attr('data-alias') );

    jQuery('#types_hours').val( item.attr('data-hours') );
    jQuery('#types_color').val( item.attr('data-color') );
    jQuery('#types_chars').val( item.attr('data-chars') );
        
    if (item.attr('data-free') == '1') {
        jQuery('#types_is_free').prop('checked', true);    
    }
    if (item.attr('data-sum-row') == '1') {
        jQuery('#types_sum_row').prop('checked', true);    
    }
    if (item.attr('data-sum-col') == '1') {
        jQuery('#types_sum_col').prop('checked', true);    
    }
}



function shift_schedule_698_showTypeBox() {

    var html = get_types_properties_html_box;

    var box = '<div id="messageBox" class="messageBox" style="z-index:1001;">' 
            + html 
            + '</div>';

    shift_schedule_698_showOverlay();
    jQuery('body').append( box );

    var t = Math.floor((jQuery(window).height() - jQuery('#messageBox').height()) / 2);
    var l = Math.floor((jQuery(window).width() - jQuery('#messageBox').width()) / 2);
    jQuery('#messageBox').css('top', t + 'px');
    jQuery('#messageBox').css('left', l + 'px');
    jQuery('#messageBox').fadeIn();
    jQuery('.link_title_label:first').focus();
    
}

function shift_schedule_698_hideTypesBox() {
    jQuery('#messageBox').hide();
    jQuery('#messageBox').remove();
    shift_schedule_698_hideOverlay();
}

function shift_schedule_698_showOverlay() {
    var over = '<div id="overlay" class="overlay" style="z-index:1000;"></div>';
    jQuery('body').prepend(over);
    jQuery('#overlay').width( jQuery(window).width() );
    jQuery('#overlay').height( jQuery(window).height() );
    jQuery('#overlay').fadeIn(200);
}

function shift_schedule_698_hideOverlay() {
    jQuery('#overlay').fadeOut(200);
    setTimeout(function() {
        jQuery('#overlay').remove();
    }, 250);    
}

function shift_schedule_698_editType() {
    var item = jQuery('#'+jQuery('#types_id').val());

    item.attr('data-title', jQuery('#types_title').val());
    item.attr('data-alias', jQuery('#types_alias').val());
    var hours = jQuery('#types_hours').val();

    hours = hours.replace(' ', '').replace(',', '.');
    item.attr('data-hours', hours);
    item.attr('data-color', jQuery('#types_color').val());
    item.attr('data-chars', jQuery('#types_chars').val());
    
    if (jQuery('#types_is_free').prop('checked')) {    
        item.attr('data-free', 1);
    } else {
        item.attr('data-free', 0);
    }
    if (jQuery('#types_sum_row').prop('checked')) {    
        item.attr('data-sum-row', 1);
    } else {
        item.attr('data-sum-row', 0);
    }
    if (jQuery('#types_sum_col').prop('checked')) {    
        item.attr('data-sum-col', 1);
    } else {
        item.attr('data-sum-col', 0);
    }
    var html = '<div class="type-color-demo" style="background-color:'+jQuery('#types_color').val()+'"></div>'+
               jQuery('#types_title').val() + ' (' + jQuery('#types_chars').val() + ') <code><small>[' + jQuery('#types_alias').val() + ']</small></code>';
    item.find('.type-info:first').html(html);
    shift_schedule_698_hideTypesBox();
    shift_schedule_698_updateTypes();    
}

function shift_schedule_698_to_alias(text) {

    text = text.replace(/^\s+|\s+$/g, '');
    text = text.toLowerCase();
      var from = "áãàáäâẽèéëêìíïîőõòóöôùúüûűñç·/_,:;";
      var to   = "aaaaaaeeeeeiiiioooooouuuuűnc------";    
    for (var i=0, l=from.length ; i<l ; i++) {
        text = text.replace(new RegExp(from.charAt(i), 'g'), to.charAt(i));
    }    
    text = text.replace(/[^a-z0-9 -]/g, '')
               .replace(/\s+/g, '-')
               .replace(/-+/g, '-');    
    
    return text;
}

function shift_schedule_698_addNewType() {

    var id = jQuery('#types_id').val();
    var title = jQuery('#types_title').val();
    var alias = jQuery('#types_alias').val();
    var hours = jQuery('#types_hours').val();
    hours = hours.replace(' ', '').replace(',', '.');

    if (alias == '') {
        alias = shift_schedule_698_to_alias(title);
    } 

    var color   = jQuery('#types_color').val();
    var chars   = jQuery('#types_chars').val();
    
    var is_free = 0;
    if (jQuery('#types_is_free').prop('checked')) {
        is_free = 1;
    }

    var sum_row = 0;
    if (jQuery('#types_sum_row').prop('checked')) {
        sum_row = 1;
    }

    var sum_col = 0;
    if (jQuery('#types_sum_col').prop('checked')) {
        sum_col = 1;
    }

    
    shift_schedule_698_hideTypesBox();

    var html = '<li class="admin-types" '+
                    'id="'+id+'" '+
                    'data-title="'+title+'" '+
                    'data-alias="'+alias+'" '+
                    'data-hours="'+hours+'" '+
                    'data-color="'+color+'" '+
                    'data-chars="'+chars+'" '+
                    'data-free="'+is_free+'" '+
                    'data-sum-row="'+sum_row+'" '+
                    'data-sum-col="'+sum_col+'" '+
                    '>' +
                   '<div class="delete-icon" onclick="shift_schedule_698_deleteType(jQuery(this))"><span class="small dashicons dashicons-trash"></span></div>' +
                   '<div class="edit-icon" onclick="shift_schedule_698_editTypeBox(jQuery(this))"><span class="small dashicons dashicons-edit"></span></div>' +
                   '<div class="type-info">'+
                   '<div class="type-color-demo" style="background-color:'+color+'"></div>'+
                   title + ' (' + chars + ') <code><small>[' + alias + ']</small></code>' +
                   '</div>' +
               '</li>';
    jQuery('#shift_schedule_698_types').append(html);
    jQuery('#no_types').remove();
    shift_schedule_698_updateTypes();
}

function shift_schedule_698_updateTypes() {
    var types = [];
    jQuery('#shift_schedule_698_types').children('li').each(function() {
        
        // var cells = this.cells;
        // console.log(cells);
        
        var id = jQuery(this).attr('id');
        var title = jQuery(this).attr('data-title');
        var alias = jQuery(this).attr('data-alias');
        var hours = jQuery(this).attr('data-hours');
    
        var color = jQuery(this).attr('data-color');
        var chars = jQuery(this).attr('data-chars');

        var free    = jQuery(this).attr('data-free');
        var sum_col = jQuery(this).attr('data-sum-col');
        var sum_row = jQuery(this).attr('data-sum-row');
        
        var type = {'title': title, 'alias': alias, 'hours': hours, 'color': color, 'chars': chars, 'free': free, 'sum_col': sum_col, 'sum_row': sum_row};
        types.push(type);
        
    });
    jQuery('#types').val( JSON.stringify(types) );
}

function shift_schedule_698_deleteType(item) {
    item.closest('li').remove();
    shift_schedule_698_updateTypes();
}

function shift_schedule_698_setCookie(month) {
    var host = window.location.host,
        exdate = new Date();
    exdate.setDate(exdate.getDate() + 365);
    document.cookie = 'shift_schedule=' + month + ';  expires=' + exdate.toUTCString() + '; path=/; domain='+host;
}

function shift_schedule_698_checkDayColl(day) {
    
    var sum = {};
    for (i = 0; i < shift_schedule_698_types.length; ++i) {
        sum[shift_schedule_698_types[i].alias] = 0;
    }

    jQuery(table_id).find('[data-day="'+day+'"]').each (function() {
        var current = jQuery(this);
        jQuery.each(sum, function (key, val) {
            if (current.hasClass(key)) {
                sum[key] = sum[key] + 1;
            }
        });
    });
    jQuery.each(sum, function (key, val) {
        if (sum[key] > 0) {
            jQuery('.sum_'+key+'_'+day).text(val);
        } else {
            jQuery('.sum_'+key+'_'+day).text('');
        }
    });
    
}
function shift_schedule_698_print() {

    var button = jQuery('#shift_schedule_698_print_preview_button');
    button.removeClass('dashicons-visibility');
    button.addClass('dashicons-update');
    button.addClass('spin');

    var data = {
            action : 'shift_schedule_698_get_css'
        };
        
    jQuery.ajax({
        url      : shift_schedule_698_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                var html = '<!DOCTYPE html>' + 
                           '<html xmlns="http://www.w3.org/1999/xhtml">' +
                           '<head>' +
                           '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />' +
                           '<title>' + jQuery('#schedule_title').text() + '</title>';
                
                html += '<style>' + data.css + '</style>'+ 
                        '</head><body>';                
                html += '<h1>' + jQuery('#schedule_title').text() + '</h1>';
                
                html += '<table class="schedules" cellspacing="1" style="width:100%;background-color:#ccc;">';
                html += '<thead>' + jQuery(table_id + ' thead').html() + '</thead>';
                html += '<tbody>' + jQuery(table_id + ' tbody').html() + '</tbody>';
                html += '<tfoot><tr class="legend">' + jQuery(table_id + ' tfoot').find('tr.legend:first').html() + '</tr></tfoot>';
                html += '</table></body></html>';
                
                var w = window.open();
                w.document.open();
                w.document.write(html);
                w.document.close();
                // Status OK

                var button = jQuery('#shift_schedule_698_print_preview_button');
                button.removeClass('dashicons-update');
                button.removeClass('spin');
                button.addClass('dashicons-visibility');

            } else {
                console.log(data.error);
            }
        } 
    });
}

function shift_schedule_698_csv() {
    var button = jQuery('#shift_schedule_698_csv_button');
    button.removeClass('dashicons-editor-table');
    button.addClass('dashicons-update');
    button.addClass('spin');

    var html = '';
    var head = [];
    jQuery(table_id + ' thead').find('tr:first').find('th').each (function() {
        head.push( jQuery(this).text() );
    });     
    html = head.join(";") + "\r\n";
    jQuery(table_id + ' tbody').find('tr').each (function() {
        var line = [];
        var tr_line = jQuery(this);
        
        jQuery(tr_line).find('td').each (function() {
            var text = jQuery(this).text();
            if (text != '') {
                line.push( text );    
            } else {
                for (i = 0; i < shift_schedule_698_types.length; ++i) {
                    if ( jQuery(this).hasClass(shift_schedule_698_types[i].alias) ) {
                        text = shift_schedule_698_types[i].chars;
                    }
                }
                line.push( text );    
            }
        });     
        html = html + line.join(";") + "\r\n";
    });     
    var filename = jQuery('#schedule_title').text();
    filename = filename.replace('.', '-').replace(' ', '');
    
    var universalBOM = "\uFEFF";
    var a = window.document.createElement('a');
    a.setAttribute('href', 'data:text/csv; charset=utf-8,' + encodeURIComponent(universalBOM+html));
    a.setAttribute('download', filename+'.csv');
    window.document.body.appendChild(a);
    a.click();    

    button.removeClass('dashicons-update');
    button.removeClass('spin');
    button.addClass('dashicons-editor-table');
}