var table_id = '';

jQuery(document).ready(function() {

    jQuery('table.schedules').each(function(){
        table_id = '#schedules_' + jQuery(this).attr('data-token');

        jQuery(table_id).find('[data-day="01"]').each(function() {
            shift_schedule_698_checkLine( jQuery(this) );
        });

    });

});

function shift_schedule_698_checkLine(item) {
    var line = item.closest('tr');
    var hour    = 0,
        szab    = 0,
        nappal  = 0,
        ejszaka = 0;
    var id = line.attr('data-id');
    var orak = parseInt(line.attr('data-hour'));

    var index = {};
    for (i = 0; i < shift_schedule_698_types.length; ++i) {
        index[shift_schedule_698_types[i].alias] = 0;
    }

    line.find('.day').each (function() {
        var day = jQuery(this);
        for (i = 0; i < shift_schedule_698_types.length; ++i) {    
            if (day.hasClass(shift_schedule_698_types[i].alias)) {
                index[shift_schedule_698_types[i].alias] = index[shift_schedule_698_types[i].alias] + 1;
                if (jQuery.isNumeric(shift_schedule_698_types[i].hours) && (Number(shift_schedule_698_types[i].hours) > 0)) {
                    hour = hour + Number(shift_schedule_698_types[i].hours);
                }
            }
        }
    });

    if (hour > 0) {
        if ((hour % 1) > 0) {
            jQuery(table_id).find('.user_'+id+'_sum').text(shift_schedule_698_number_format(hour, 1, '.', ' '));
        } else {
            jQuery(table_id).find('.user_'+id+'_sum').text(hour);
        }
    } else {
        jQuery(table_id).find('.user_'+id+'_sum').text('');
    }
    var plus = hour - orak;
    if (plus > 0) {
        if ((plus % 1) > 0) {
            jQuery(table_id).find('.user_'+id+'_plus').text(shift_schedule_698_number_format(plus, 1, '.', ' '));
        } else {
            jQuery(table_id).find('.user_'+id+'_plus').text(plus);
        }
    } else {
        jQuery(table_id).find('.user_'+id+'_plus').text('');
    }

    for (i = 0; i < shift_schedule_698_types.length; ++i) {
        if (shift_schedule_698_types[i].sum_row == '1') {
            if (index[shift_schedule_698_types[i].alias] > 0) {
                jQuery(table_id).find('.user_'+id+'_'+shift_schedule_698_types[i].alias).text(index[shift_schedule_698_types[i].alias]);
            } else {
                jQuery(table_id).find('.user_'+id+'_'+shift_schedule_698_types[i].alias).text('');
            }    
        }
    }
    
    shift_schedule_698_checkSumPlus();
    
    for (i = 0; i < shift_schedule_698_types.length; ++i) {
        if (shift_schedule_698_types[i].sum_row == '1') {
            var sum = 0;
            jQuery(table_id).find('.line-'+shift_schedule_698_types[i].alias).each (function() {
                if (parseInt( jQuery(this).text() )) {
                    sum = sum + parseInt( jQuery(this).text() );
                }
            });
            if (sum > 0) {
                jQuery(table_id).find('.sum_'+shift_schedule_698_types[i].alias).text(sum);
            } else {
                jQuery(table_id).find('.sum_'+shift_schedule_698_types[i].alias).text('');
            }
        }
    }
    
}

function shift_schedule_698_checkSumPlus() {
    var sum = 0;
    jQuery(table_id).find('.line-plus').each (function() {
        if (parseInt( jQuery(this).text() )) {
            sum = sum + parseInt( jQuery(this).text() );
        }
    });
    if (sum > 0) {
        if ((sum % 1) > 0) {
            jQuery(table_id).find('.sum_plus').text(shift_schedule_698_number_format(sum, 1, '.', ' '));
        } else {
            jQuery(table_id).find('.sum_plus').text(sum);
        }
    } else {
        jQuery(table_id).find('.sum_plus').text('');
    }
}

function shift_schedule_698_number_format(number, decimals, dec_point, thousands_sep) {
  number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
  var n = !isFinite(+number) ? 0 : +number,
    prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
    sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
    dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
    s = '',
    toFixedFix = function (n, prec) {
      var k = Math.pow(10, prec);
      return '' + Math.round(n * k) / k;
    };
  // Fix for IE parseFloat(0.55).toFixed(0) = 0;
  s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
  if (s[0].length > 3) {
    s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
  }
  if ((s[1] || '').length < prec) {
    s[1] = s[1] || '';
    s[1] += new Array(prec - s[1].length + 1).join('0');
  }
  return s.join(dec);
};

