<?php
function shift_schedule_698_update_free()
{
    $user = null;
    if (isset($_REQUEST['user']) && !empty($_REQUEST['user'])) {
        $user = sanitize_text_field($_REQUEST['user']);
    } 

    $mode = null;
    if (isset($_REQUEST['mode']) && !empty($_REQUEST['mode'])) {
        $mode = sanitize_text_field($_REQUEST['mode']);
    } 
    
    if (($user != null) && ($mode != null)) {
        $free = get_post_meta( $user, 'custom_free', true );
        if ($mode == '+') {
            $free = $free + 1; 
        } else {
            $free = $free - 1;
        }        
        update_post_meta($user, 'custom_free', $free);
        $result = array(
            'status' => 1,
            'user'   => $user,
            'day'    => $free
        );
        echo json_encode($result);          
        wp_die();
    }
    
    $result = array(
        'status' => 0,
        'error'  => __('User or mode not set!', 'shift-schedule')
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_shift_schedule_698_update_free', 'shift_schedule_698_update_free' );

function shift_schedule_698_set_boss()
{
    global $wpdb;
    
    $user = null;
    if (isset($_REQUEST['user']) && !empty($_REQUEST['user'])) {
        $user = sanitize_text_field($_REQUEST['user']);
    } 

    $day = null;
    if (isset($_REQUEST['day']) && !empty($_REQUEST['day'])) {
        $day = sanitize_text_field($_REQUEST['day']);
    } 

    $boss = 0;
    if (isset($_REQUEST['boss']) && !empty($_REQUEST['boss'])) {
        $boss = sanitize_text_field($_REQUEST['boss']);
    } 
    
    if (($user != null) && ($day != null)) {

        $table_name = $wpdb->prefix . 'shift_schedule';
        $query = 'SELECT * FROM `'.$table_name.'` ' .
                 'WHERE ' .
                    '`user_id` = "'.$user.'" AND ' .
                    '`day` = "'.$day.'"';
        $data = $wpdb->get_results($query);
        if ($wpdb->last_error !== '') {
            $result = array(
                'status' => 0,
                'error'  => htmlspecialchars( $wpdb->last_result, ENT_QUOTES )
            );
            echo json_encode($result);          
            wp_die();
        } else {
            if (empty($data)) {
                $query = 'INSERT INTO `'.$table_name.'` ' .
                         'SET ' .
                            '`user_id` = "'.$user.'", ' .
                            '`day` = "'.$day.'", ' .
                            '`boss` = "'.$boss.'"';
                $wpdb->query($query);
            } else {
                $query = 'UPDATE `'.$table_name.'` ' .
                         'SET ' .
                            '`boss` = "'.$boss.'" ' . 
                         'WHERE ' .
                            '`id` = "'.$data[0]->id.'"';
                $wpdb->query($query);
            }
            if ($wpdb->last_error !== '') {
                $result = array(
                    'status' => 0,
                    'error'  => htmlspecialchars( $wpdb->last_result, ENT_QUOTES )
                );
                echo json_encode($result);          
                wp_die();
            } else {
                $result = array(
                    'status' => 1
                );
                echo json_encode($result);          
                wp_die();
            }
        }
        wp_die();
    }
    
    $result = array(
        'status' => 0,
        'error'  => __('User or mode not set!', 'shift-schedule')
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_shift_schedule_698_set_boss', 'shift_schedule_698_set_boss' );

function shift_schedule_698_set_flag()
{
    global $wpdb;
    
    $user = null;
    if (isset($_REQUEST['user']) && !empty($_REQUEST['user'])) {
        $user = sanitize_text_field($_REQUEST['user']);
    } 

    $day = null;
    if (isset($_REQUEST['day']) && !empty($_REQUEST['day'])) {
        $day = sanitize_text_field($_REQUEST['day']);
    } 

    $flag = null;
    if (isset($_REQUEST['flag']) && !empty($_REQUEST['flag'])) {
        $flag = sanitize_text_field($_REQUEST['flag']);
    } 
    
    if (($user != null) && ($day != null)) {

        $table_name = $wpdb->prefix . 'shift_schedule';
        $query = 'SELECT * FROM `'.$table_name.'` ' .
                 'WHERE ' .
                    '`user_id` = "'.$user.'" AND ' .
                    '`day` = "'.$day.'"';
        $data = $wpdb->get_results($query);
        if ($wpdb->last_error !== '') {
            $result = array(
                'status' => 0,
                'error'  => htmlspecialchars( $wpdb->last_result, ENT_QUOTES )
            );
            echo json_encode($result);          
            wp_die();
        } else {
            if (empty($data)) {
                $query = 'INSERT INTO `'.$table_name.'` ' .
                         'SET ' .
                            '`user_id` = "'.$user.'", ' .
                            '`day` = "'.$day.'", ' .
                            '`flag` = "'.$flag.'"';
                $wpdb->query($query);
            } else {
                $query = 'UPDATE `'.$table_name.'` ' .
                         'SET ' .
                            '`flag` = "'.$flag.'" ' . 
                         'WHERE ' .
                            '`id` = "'.$data[0]->id.'"';
                $wpdb->query($query);
            }
            if ($wpdb->last_error !== '') {
                $result = array(
                    'status' => 0,
                    'error'  => htmlspecialchars( $wpdb->last_result, ENT_QUOTES )
                );
                echo json_encode($result);          
                wp_die();
            } else {
                $result = array(
                    'status' => 1
                );
                echo json_encode($result);          
                wp_die();
            }
        }
        wp_die();
    }
    
    $result = array(
        'status' => 0,
        'error'  => __('User or mode not set!', 'shift-schedule')
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_shift_schedule_698_set_flag', 'shift_schedule_698_set_flag' );

function shift_schedule_698_get_css() {

    $css = file_get_contents( SHIFT_SCHEDULE_698_ROOT . '/assets/css/shift-schedule.css');

    $options = shift_schedule_698_get_options();
    
    $custom_css = array();
    $custom_css[] = 'body {font-family: Arial, Helvetica, sans-serif;font-size:12px;}';
    foreach ($options['types'] as $type) {
        $custom_css[] = 'table.schedules td.'.$type->alias.' { background-color: ' .$type->color. ' !important; }';
        $custom_css[] = 'table.schedules td.'.$type->alias.':after { content: "' .$type->chars. '"; }';
    }
    $custom_css = implode("\r\n", $custom_css);
    $css .= $custom_css;    

    $result = array(
        'status' => 1,
        'css'    => $css
    );
    echo json_encode($result);
    wp_die();
    
}
add_action( 'wp_ajax_shift_schedule_698_get_css', 'shift_schedule_698_get_css' );


function shift_schedule_698_import_wordpress_users() {

    $group = null;
    if (isset($_REQUEST['group']) && !empty($_REQUEST['group'])) {
        $group = sanitize_text_field($_REQUEST['group']);
    } 

    $args = array(
        'orderby' => 'user_nicename',
        'order'   => 'ASC'
    );
    if (!empty($group)) { $args['role'] = $group; }

    $users = get_users( $args );

    if (!empty($users)) {
        foreach ($users as $user) {
            $options = array(
                'ID'                    => 0,
                'post_date'             => current_time('mysql'),
                'post_title'            => $user->display_name,
                'post_status'           => 'publish',
                'post_type'             => 'schedule-user',
                'post_parent'           => 0
            );
            $post_id = wp_insert_post($options);
            add_post_meta( $post_id, 'custom_free', 0);
            add_post_meta( $post_id, 'custom_hours', 8);
        }
    }

    $result = array(
        'status'  => 1,
        'message' => sprintf( __('%s user(s) imported.', 'shift-schedule'), count($users))
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_shift_schedule_698_import_wordpress_users', 'shift_schedule_698_import_wordpress_users' );
