<?php

if ( ! class_exists( 'Dovi42_Meta_Box_Inputs') ) :

    class Dovi42_Meta_Box_Inputs extends stdClass {

        var $options = array();
        var $css = array();
        var $js = array();
        var $value = null;

        public function __construct($options)
        {
            $this->options = wp_parse_args($options, $this->options);
            add_action( 'admin_enqueue_scripts', array( $this, 'load_scripts_and_styles' ) );
        }
        
        function load_scripts_and_styles() {
            
            $i = 0;
            $this->_path = dirname( __file__ );
            if (!empty($this->css)) {
                foreach ($this->css as $css) {
                    wp_register_style($this->options['type'].'-'.$i.'-css', plugins_url('inputs/css/'.$css, $this->_path) );
                    wp_enqueue_style( $this->options['type'].'-'.$i.'-css' );
                }
            }
            if (!empty($this->js)) {
                foreach ($this->js as $js) {
            	   wp_enqueue_script($this->options['type'].'-'.$i.'-js', plugins_url('inputs/js/'.$js, $this->_path), array('jquery') );
                }
            }
        }

        function render($post_id) {
            
            $this->value = get_post_meta($post_id, $this->options['meta_key'] .'_'. $this->options['id'], true);
        }

        function sanitize() {
            $this->value = trim( strip_tags($this->value) );
        }

        function check() {
            return (isset($_POST[$this->options['meta_key'] .'_'.$this->options['id']]));
        }

        function getValue() {

            $this->value = $_POST[$this->options['meta_key'] .'_'.$this->options['id']];
            $this->sanitize();
        }

        function save($post_id) {
            
            if ($this->check()) {

                $this->getValue();

                if ( get_post_meta( $post_id, $this->options['meta_key'] .'_'.$this->options['id'] , false ) ) {
            		update_post_meta( $post_id, $this->options['meta_key'] .'_'.$this->options['id'], $this->value );
            	} else {
            		add_post_meta( $post_id, $this->options['meta_key'] .'_'.$this->options['id'], $this->value );
            	}
            }
        }

    }
endif;