<?php

function shift_schedule_698_declarate_schedule_user_cpt() {
    
    register_taxonomy(
        'schedule-category',
        'schedule-user',
        array(
            'labels' => array(
            		'name'            => _x( 'Categories', 'Taxonomy General Name', 'shift-schedule' ),
            		'singular_name'   => _x( 'User Category', 'Taxonomy Singular Name', 'shift-schedule' ),
            		'menu_name'       => __( 'Users categories', 'shift-schedule' ),
            		'all_items'       => __( 'All categories', 'shift-schedule' ),
            		//'add_new_item'    => __( 'Add new category', 'shift-schedule' ),
                ),
            'rewrite' => array( 'slug' => 'schedule-category' ),
            'hierarchical' => true,
            'show_ui'           => true,
            'query_var'         => true,
            'show_admin_column' => true, 
            'show_in_nav_menus' => true,   
        )
    );
    
    
	$labels = array(
		'name'                  => _x( 'Schedule users', 'Post Type General Name', 'shift-schedule' ),
		'singular_name'         => _x( 'Schedule user', 'Post Type Singular Name', 'shift-schedule' ),
		'menu_name'             => __( 'Schedule users', 'shift-schedule' ),
		'name_admin_bar'        => __( 'Schedule users', 'shift-schedule' ),
		'parent_item_colon'     => __( 'Parent Item:', 'shift-schedule' ),
		'all_items'             => __( 'All users', 'shift-schedule' ),
		'add_new_item'          => __( 'Add New user', 'shift-schedule' ),
		'new_item'              => __( 'New user', 'shift-schedule' ),
		'edit_item'             => __( 'Edit user', 'shift-schedule' ),
		'item title'            => __( 'Edit title', 'shift-schedule' ),
		'update_item'           => __( 'Update user', 'shift-schedule' ),
	);
	$rewrite = array(
		'slug'                  => 'schedule-user',
		'with_front'            => true,
		'pages'                 => true,
		'feeds'                 => true,
	);
	$args = array(
		'label'                 => __( 'Schedule user', 'shift-schedule' ),
		'description'           => __( 'Shift schedule description', 'shift-schedule' ),
		'labels'                => $labels,
		'supports'              => array( 'title', 'editor', 'thumbnail'),
		'taxonomies'            => array('schedule-category'),
		'hierarchical'          => false,
		'public'                => true,
		'show_ui'               => true,
		'show_in_menu'          => true,
		'menu_position'         => 5,
		'menu_icon'             => 'dashicons-groups',
		'show_in_admin_bar'     => false,
		'show_in_nav_menus'     => false,
		'can_export'            => true,
		'has_archive'           => true,
		'exclude_from_search'   => true,
		'publicly_queryable'    => true,
		'rewrite'               => $rewrite,
		'capability_type'       => 'post',
		'show_in_rest'          => true,
		'rest_base'             => 'schedule-user',
	);
	register_post_type( 'schedule-user', $args );
    
}
add_action( 'init', 'shift_schedule_698_declarate_schedule_user_cpt', 0 );

function shift_schedule_698_new_title( $title ) {

	$screen = get_current_screen()->post_type;
    if ($screen == 'schedule-user') {
        $title = __('User name', 'shift-schedule');
    }
	return $title;
}
add_filter( 'enter_title_here', 'shift_schedule_698_new_title' );


/**
 * Adds "Import" button on module list page
 */
function addCustomImportButton() {
    global $current_screen;

    // Not our post type, exit earlier
    // You can remove this if condition if you don't have any specific post type to restrict to. 
    if ('schedule-user' != $current_screen->post_type) {
        return;
    }

    wp_register_style( 'shift-schedule', plugins_url( 'shift-schedule/assets/css/shift-schedule-admin.css', SHIFT_SCHEDULE_698_ROOT ), array(), SHIFT_SCHEDULE_698_VERSION );
	wp_enqueue_style( 'shift-schedule' );

	wp_register_script('shift-schedule-js', '', array('jquery'), SHIFT_SCHEDULE_698_VERSION, true);
	wp_localize_script('shift-schedule-js', 'shift_schedule_698_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
	wp_enqueue_script('shift-schedule-js');

    ?>
        <div id="include_import" style="display:none;">
            <div>
                <select name="import_role" id="import_role">
                    <option value=""><?php echo __('All WordPress users', 'shift-schedule');?></option>
                    <?php wp_dropdown_roles(); ?>
                </select>
                <a onclick="import_from_worpress();" id="import_users_button" class="add-new-h2" style="top: 2px;"><?php echo __('Import WordPress users', 'shift-schedule');?></a>
            </div>
            <div>
                <?php echo __('Import <strong>all users</strong> in group! <em>(Does not examine whether there exists.)</em>', 'shift-schedule');?>
            </div>
        </div>

        <script type="text/javascript">
            jQuery(document).ready( function() {
                var import_selector = jQuery('#include_import').html();
                jQuery('#include_import').remove();
                jQuery(".wrap").append(import_selector);
            });
    
            function import_from_worpress() {
                
                jQuery('#import_users_button').prepend('<span class="dashicons dashicons-update-alt spin" style="margin-top: 3px;"></span>');
                
                var data = {
                        action : 'shift_schedule_698_import_wordpress_users',
                        group  : jQuery('#import_role').val()
                    };
                    
                jQuery.ajax({
                    url      : shift_schedule_698_ajax_object.ajax_url,
                    dataType : 'json',
                    type     : 'POST',
                    data     : data,
                    success  : function(data, result){
                        if (data.status == 1) {
                            // Status OK
                            jQuery('#import_users_button').find('.dashicons').remove();
                            alert(data.message);
                            location.reload(); 
                        } else {
                            console.log(data.error);
                        }
                    } 
                });
            }
        </script>
    <?php
}
add_action('admin_head-edit.php','addCustomImportButton');